// naumann@stce.rwth-aachen.de

#pragma once

#include "config.h"

template<typename T>
VT<T> g(VT<T> p, T x, VT<T> y);

/// explicit Euler simulation of differential model
template<typename T>
VT<T> f(VT<T> p, T x) { 
  // condition
  assert(x>0);
  // integration step size
  T delta_x=x/m;
  // initial position fixed to zero
  x=0;
  // initial state fixed to zero
  VT<T> y=VT<T>::Zero(n);
  int i=0;
  while (i<m) {
    // explicit Euler step
    y=y+delta_x*g(p,x,y); 
    x=x+delta_x;
    i=i+1;
  } 
  return y;
}
