// naumann@stce.rwth-aachen.de

#pragma once

#include "config.h"

/// linear (in p) right-hand side of the explicit ordinary differential equation independent of y
template<typename T>
VT<T> g(VT<T> p, T x, VT<T> /*y*/) {
  // conditions
  assert(p.size()==np);
  assert(np==2*n);
  // result
  VT<T> dydx(n);
  // evaluation of result
  int i=0;
  while (i<n) {
    dydx(i)=p(i)/(x+1)+p(n+i);
    i=i+1;
  }
  return dydx;
}
