// naumann@stce.rwth-aachen.de

#pragma once

#include "config.h"

/// dependence of right-hand side on y yields nonlinear (in p) model
template<typename T>
VT<T> g(VT<T> p, T x, VT<T> y) {
  // conditions
  assert(p.size()==np);
  assert(y.size()==n);
  assert(np==2*n);
  // result
  VT<T> dydx(n);
  // evaluation of result
  int i=0;
  dydx(i)=p(i)*x/(y(i)+1)+p(i+1)*x/(y(i+1)+1)+p(n+i);
  i=i+1;
  while (i<n-1) {
    dydx(i)=p(i-1)*x/(y(i-1)+1)+p(i)*x/(y(i)+1)+p(i+1)*x/(y(i+1)+1)+p(n+i);
    i=i+1;
  }
  dydx(i)=p(i-1)*x/(y(i-1)+1)+p(i)*x/(y(i)+1)+p(n+i);
  return dydx;
}
