// naumann@stce.rwth-aachen.de

#pragma once

#include "config.h"
#include "residual.h"

// linear regression method determined at link time
template<typename T>
VT<T> linear_regression(MT<T> drdp, VT<T> yobs);

template<typename T>
VT<T> fit(VT<T> p, VT<T> xobs, MT<T> yobs) {
  assert(p.size()==np);
  assert(xobs.size()==nobs);
  assert(yobs.rows()==nobs);
  assert(yobs.cols()==n);
  VT<T> yobs_serial(nobs*n);
  int i=0;
  while (i<nobs) {
    int j=0;
    while (j<n) {
      yobs_serial(i*n+j)=yobs(i,j);
      j=j+1;
    }
    i=i+1;
  }
  return linear_regression(dr_dp(p,xobs,yobs),yobs_serial);
}
