// naumann@stce.rwth-aachen.de

#pragma once

#include "config.h"

/// linear regression by normal equation method
template<typename T>
VT<T> linear_regression(MT<T> drdp, VT<T> yobs) {
  // conditions
  assert(yobs.size()==nobs*n);
  assert(drdp.rows()==nobs*n);
  assert(drdp.cols()==np);
  // normal equation
  return (drdp.transpose()*drdp).llt().solve(drdp.transpose()*yobs);
}
