// naumann@stce.rwth-aachen.de

#pragma once

#include "config.h"

#include "dco.hpp"

template<typename T>
VT<T> f(VT<T> p, T x);

template<typename T>
VT<T> r(VT<T> p, VT<T> xobs, MT<T> yobs) {
  assert(p.size()==np);
  assert(xobs.size()==nobs);
  assert(yobs.rows()==nobs);
  assert(yobs.cols()==n);
  VT<T> r_(nobs*n);
  int k=0;
  int i=0;
  while (i<nobs) {
    VT<T> r_i=f(p,xobs(i))-yobs.row(i).transpose();
    int j=0;
    while (j<n) {
      r_(k)=r_i(j);
      j=j+1;
      k=k+1;
    }
    i=i+1;
  }
  return r_;
}

template<typename T>
MT<T> dr_dp(VT<T> p, VT<T> xobs, MT<T> yobs) {
  assert(p.size()==np);
  assert(xobs.size()==nobs);
  assert(yobs.rows()==nobs);
  assert(yobs.cols()==n);
  using TT=dco::gt1s<T>::type;
  VT<TT> p_t(np), xobs_t(nobs);
  MT<TT> yobs_t(nobs,n);
  int i=0;
  while (i<np) {
    p_t(i)=p(i);
    i=i+1;
  }
  i=0;
  while (i<nobs) {
    xobs_t(i)=xobs(i);
    int j=0;
    while (j<n) {
      yobs_t(i,j)=yobs(i,j);
      j=j+1;
    }
    i=i+1;
  }
  MT<T> drdp(nobs*n,np);
  i=0;
  while (i<np) {
    dco::derivative(p_t(i))=1;
    VT<TT> drdp_t=r(p_t,xobs_t,yobs_t);
    int j=0;
    while (j<nobs*n) {
      drdp(j,i)=dco::derivative(drdp_t(j));
      j=j+1;
    }
    dco::derivative(p_t(i))=0;
    i=i+1;

  }
  return drdp;
}

